/*
   Author:  Jianfei Zhu  
            Concordia University
   Date:    Sep. 26, 2003

Copyright (c) 2003, Concordia University, Montreal, Canada
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

   - Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
   - Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.
   - Neither the name of Concordia University nor the names of its
       contributors may be used to endorse or promote products derived from
       this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.

*/
#ifndef COMMON_H
#define COMMON_H

#include <time.h>
#include "buffer.h"
#include "data.h"
//#include "fk_tree.h"
#include "fsout.h"
//#include "fp_tree.h"


#define CLOSE

#define SUDDEN 5
#define SWITCH 15

class stack;

const int power2[29] = {1, 2, 4, 8,
			16, 32, 64, 128, 256,
			512, 1024, 2048, 4096, 
			8192, 16384, 32768, 65536, 
			131072, 262144, 524288,1048576, 
			2097152, 4194304, 8388608,16777216, 
			33554432, 67108864, 134217728, 268435456};	

extern int TRANSACTION_NO;   //number of transactions
extern int POSITIVE_NO;
extern int ITEM_NO;          //maximal number of items at beginning, later on, shrink to number of frequent items.
extern int THRESHOLD;        //threshold by the parameter
extern double RATIO_THRESHOLD;  //odds ratio threshould
extern int* order_item;	     // given order i, order_item[i] gives the original itemname, corresponding to table
extern int* item_order;		 // given item i, item_order[i] gives its new order, corresponding to order 
                             //	order_item[item_order[i]]=i; item_order[order_item[i]]=i; 
extern memory* fp_buf;
extern memory* fp_buf1;
extern bool* current_fi;     //to be use for maximal or close patterns.
extern int* compact;         //the current itemset, represented by the set of orders in current table.
extern int* supp;            //use in conditional_pattern_base  to store support temporarily

extern int *ITlen;     //the number of itemset with a specific length
extern int* bran;      //the number of branches
extern int* prefix;    //just used in enumerate itemset

extern stack* list;    //stack object 
//extern hash_table *patternTable;

//extern MFI_tree** mfitrees;

//extern CFI_tree** cfitrees;

extern int nodeCount;

void sort(int *array, int* temp, int i, int j);


static int INTSIZE=sizeof(int);

extern inline bool testRatio(int totalSupport, int positiveSupport, int dbSize, int posSize, double threshold);
#endif