#include <stdlib.h>
#include <assert.h>
#include <math.h>
//#include "fk_node.h"
#include "fk_tree.h"
#include "common.h"

extern int TIDLENGTH;

static int KNODESIZE=sizeof(Knode);

//copy one set to another, space should be allocated first.
bool Copy(int *dst, int &dstLen, int *src, int len)
{
  for(dstLen=0;dstLen<len;dstLen++)
	  dst[dstLen]=src[dstLen];

  return true;
}

//intersection of the two sets.
bool Intersection(int *&dst, int & len1, int * src, int len2, bool reverse)
{
   int len=len1;
   if(len>len2)
	   len=len2;
   int *temp=(int *)fp_buf->newbuf(len,INTSIZE); 
   int cur1=0; 
   int cur2=0;
   len=0;
   while((cur1<len1)&&(cur2<len2))
   {
     if(dst[cur1]==src[cur2])
	 {
        temp[len++]=dst[cur1];
		cur1++;
		cur2++;
		continue;
     }else if(reverse)
	 {
		  if(dst[cur1]>src[cur2])
		    cur1++;
	      else cur2++;
     }else
	 {
		  if(dst[cur1]<src[cur2])
		    cur1++;
	      else cur2++;

	 }
   }
   Copy(dst,len1,temp, len); //may be cost
   return true;
}

bool Insert(int *dstSet, int &dstLen, int item) //dstSet should have one more space
{
   for(int i=dstLen-1;i>=0;i--)
   {
     if(item<dstSet[i])
		 dstSet[i+1]=dstSet[i];
	 else if(item>dstSet[i])
     {
        dstSet[i+1]=item;
		dstLen++;
		return true;
     }else
     {
	   for(int j=i+1;j<dstLen;j++)
		   dstSet[j]=dstSet[j+1];
	   return false;
     }//the item is equal to some item, copy back
   }
   dstSet[0]=item;
   dstLen++;
   return true;
}


void Knode::init(Knode* parent, int Itemname, int Count, int PosCount, int Depth)
{
	itemname = Itemname;
	par = parent;
	leftchild = NULL;
	rightsibling = NULL;
	count = Count;
	next = NULL;
    posCount=PosCount; //should change here.
	depth = Depth;

#ifdef CLOSE
	tailSet=NULL;
	tailSize=0;
	tailSupport=0;

	TidSet = NULL;
	TidSetSize =0;
	TidLength = 0;
#endif
	//level = Level;
	nodeCount++;
}

Knode::~Knode()
{
}

#ifdef CLOSE
void Knode::addTail(int * & inTailSet, int inTailSize, int support)
{
  if(tailSize==0)
  {
    tailSize=inTailSize;  
    tailSet=inTailSet;  
	tailSupport=support;
	return;
  }else //inTailSize should >0
    {
	  Intersection(tailSet,tailSize, inTailSet, inTailSize, false);
	  if(tailSize>0)
	    tailSupport+=support;
	  else
		tailSupport=0;
	}
}

int Knode::addTid(int tid)
{
	if(TidSet == NULL)
	{
		printf("tid error! add tid");
		scanf("press to exit");
		exit(2);
	}
	
	Insert(TidSet, TidLength, tid);

	if(TidLength>TidSetSize)
	{
		printf("tid error! tid length");
		scanf("press to exit");
		exit(2);
	}

	return 1;
}


int Knode::addTidSet(int *tidSet, int tidLength)
{
	if(TidSet == NULL)
	{
		printf("tid error! add tidSet");
		scanf("press to exit");
		exit(2);
	}

	for(int i=0; i< tidLength; i++)
	{
		Insert(TidSet, TidLength, tidSet[i]);
	}

	if(TidLength>TidSetSize)
	{
		printf("tid error! tidSet length");
		scanf("press to exit");
		exit(2);
	}
	
	return 1;
}
#endif

Knode* Knode::append(FK_tree* fptree, Knode* sib, int itemno, int Count, int PosCount)
{
	Knode* child;

	child = (Knode*)fp_buf->newbuf(1, KNODESIZE);
    child ->init(this, itemno, Count, PosCount, this->depth+1);
    
	nodeCount++;
	
	if(this->leftchild==NULL)this->leftchild=child;
	else
		sib->rightsibling = child;

	int itemOrd=fptree->order[itemno];
	Knode * linkHead=fptree->head[itemOrd];
	child->next = linkHead->next;
	linkHead->next = child;
    linkHead->posCount+=PosCount;

	return child;
}


