#ifndef FK_NODE_H
#define FK_NODE_H

//#include "fp_node.h"
#include "common.h"

class FK_tree;

class FPnode{
public:
	int itemname;  //item name, by compact name

public:
//	FPnode(FPnode* par, int itemname, int count);
//	~Fnode();
};

class Knode : public FPnode{
public:
	Knode* par; //parent
	Knode* leftchild;
	Knode* rightsibling;
	Knode* next;  //node link
	int count;   //count of the path
    int posCount; //for count the positive dataset.
	int depth;

#ifdef CLOSE
	int *tailSet;  //the itemset occur in some transactions containing the prefix,
	               //can allocate from the heap
	int tailSize;  //the size of tailSet
	int tailSupport; //support for the tail;
	void addTail(int * & tailSet, int tailSize, int support);

	int *TidSet; //transaction id set with the support of most freq item as size
	int TidSetSize; //size of tidset
	int TidLength; //last tid position

	int addTidSet(int *tidSet, int tidLength); //allocate memory for the set
	int addTid(int tid);
#endif
    //int level;  //not used now.
public:
	~Knode();

	void init(Knode* parent, int itemname, int count, int posCount, int Depth=0); //initialize a node
    
	Knode* append(FK_tree* fptree, Knode* sib, int itemno, int counts, int posCount);  
	//append a node as the child, return the new child
	
	//append a node with tids
	//int insertTid(Knode* current, int tid);
	//int insertTidSet(Knode* current, int *tidSet, int tidLength);

};   

bool Intersection(int * &dst, int & len1, int * src, int len2, bool reverse);
//intersection of the two sets.

bool Copy(int *dst, int &dstLen, int *src, int len);
//copy one set to another, space should be allocated first.

bool Insert(int *dstSet, int & dstLen, int item);
//Insert an item into a set, space should be allocated first

#endif