#ifndef FK_TREE_H
#define FK_TREE_H
#include "fk_node.h"
//#include "fp_tree.h"

typedef struct tidstruct{
	bool set;
	int tid;
	int *tidSet;
	int tidLength;
}TID_STRUCT;

class FP_tree {
public:
	int itemno;		//Header_table, number of items in current tree
	int *order;		//Header_table  from item-->order
	int *table;		//orders[table[i]]=i; table[orders[i]]=i;  from order->item

public:
	~FP_tree(){};
};

class FK_tree: public FP_tree{
public:
	Knode*  Root;    //root node
	Knode** head;	//Header_table, point to the first node, array of nodes, record itemname and counts

	int**   array;    //the length of array is itemno-1; for each array[i], array[i][j] keeps the support of ij.
	int*    count;    //Header_table, the counts of each item in the head table

	int *   prefixSet; //just store the pointer
	int     prefixSize;

	int *   fullSet;   //the item that occur in every transactions in the conditional base
	                 //can allocate from the heap
	int     fullSize;  //the number of items in fullSet

    static bool bClass;    
	static int  posItem;
    
protected:
	double  level_25; // an index of branch statistics
	int     prefixCount;

	int    conditional_pattern_base(int itemname, int currPrefixCount, int *currKeySet, int currKeySize); //count the support from array in conditional base and put freqent ones into the stack, and put supports in supp variable, according to the old order
	int    conditional_pattern_base(Knode* node,  int currPrefixCount, int *currKeySet, int currKeySize);  //count the support from original conditional base and put frequent ones into the stack, and put supports in supp variable
	void   scan1_DB(FK_tree* old_tree, int *keySet, int keySize); //build header_table for the new tree from old tree and stack, including order, table, head, array			
	bool   ScanNodeLink(FK_tree *fptree, Knode *node, int * &retFullSet, int &retFullSize, int bInsert);
    void   scan2_DB(FK_tree* old_tree, Knode* node);//build the conditional fp-tree from old true and old head node, construct the new tree
	   //should add more things in. Check every node.
	void   fill_count(int* origin, int support); //compact the path into compact and store the support into the array, origin: a set of flag based on the new order order-->something
	
	Knode* insert(int* compact, int counts, int current, int posCount); //insert a compact order(new or old?) set into the current tree, current is the number of items
	Knode* insert(int* compact, int counts, int current, int posCount, TID_STRUCT* tidstt); 
	
	void   cal_level_25(); //calculate leve_25 index

  	bool   keyCheck(int *iSet, int length, int support, int newItem);
    bool   outputKey(FSout* fout,int length,int *iSet,  int support);


	bool   pruneByRatio(Knode* node);
	//debug function
	bool printStack();

	bool checkPath(Knode* node, int* iset, int length);
	int getTidSet(Knode* node, int* tidSet, int &tidLen);

#ifdef CLOSE
  	bool   CheckSubtree(Knode *root, int *localSupp, int &lMin, int &lMax, int *sumSupp);
	    //check the subtree rooted at 'root', put the support into the localSupp array.
    bool   GetTailSet(int support, int *&supp, int start, int end, int *&retSet, int & retSize); 
	    //get tailSet the support array
	bool   outputClose(FSout *fout, int *iKeySet, int keyLen, int *fulLSet, int fullLen, int support);
#endif
    

public:
	void init(int Itemno, int new_item_no); //itemno: the number of items in old tree, new_item_no, the new number, allocate the space for all pointer and init
    void scan1_DB(Data* fdat, double threshold);		//find the count of all nodes from origional DB,//build header_table, including itemno, transaction_no, order, table, head, array, transform the item name
	void scan2_DB(Data* fdat);		//construct the first fp-tree from origional DB
	bool Single_path(bool close=false)const;   //Is it a single path?
	void generate_all(int new_item_no, FSout* fout, FSout *foutClose); //generate all set for a single path, the number is in first parameter, items are in list
	int  FKP_growth(FSout* fout, FSout *foutClose);
    
	int insertTid();

	//given an ec, scan fptree for its tid
	int scanTid(int* iset, int length, int*& tidSet, int maxLen, int &tidLen);

	//for testing of depth
	bool traverseTree(Knode* node, int level);

    ~FK_tree();
	//scan each key pattern in the hash table, find the corresponding close patterns.
	//will cancal this memeber.

};


class stack{
public:
	int top;  //the pointer for next item
	int* FS;  //the set of items in the stack
	int* counts;  // the count of items for close patterns
public:
	stack(int length, bool close=false); // the maximal number of items,  be close or not.
	~stack();

	//void insert(FI_tree* fptree);
};

#endif