#include "fsout.h"
#include "common.h"


FSout::FSout(char *filename)
{
  out = fopen(filename,"wt");
}

FSout::~FSout()
{
  if(out) fclose(out);
}

int FSout::isOpen()
{
  if(out) return 1;
  else return 0;
}


void FSout::printSet(int length, int *iset, int support)
{ 
  //#ifdef shown
  for(int i=0; i<length; i++) 
  {
	fprintf(out, "%d ", order_item[iset[i]]);
//	printf("%d ", order_item[iset[i]]);
  }
  fprintf(out, "(%d)\n", support);

  // printf("(%d)\n", support);
//#endif
}

#ifdef _DEBUG
void swapInt(int* k, int* j)
{
	int temp;
	temp = *j;
	*j = *k;
	*k = temp;
}


//for debug
void inssort(int* array, int i, int j)
{
	for (int k=j-1; k>=i; k--)
		for (int m=k; (m<j) && (array[m] > array[m+1]); m++)
		{
			swapInt(array+m, array+m+1);
		}
}
#endif

void FSout::printSet(int length, int *iset, int support, int posCount)
{
#ifdef _DEBUG
  int *temp =new int[length];
  for(int j=0;j<length;j++)
  {
      temp[j]=order_item[iset[j]];
  }
  inssort(temp,0, length-1);
#endif

  for(int i=0; i<length; i++) 
  {
#ifdef _DEBUG
	fprintf(out, "%d ", temp[i]);
#else
	fprintf(out, "%d ", order_item[iset[i]]);
#endif
  }
  fprintf(out, "(%d, %d) ", posCount, support-posCount);

#ifdef _DEBUG
  delete temp;
#endif

//#endif
}

  

void FSout::printset(int length, int *iset)
{
//#ifdef shown 
  for(int i=0; i<length; i++) 
    fprintf(out, "%d ", order_item[iset[i]]);
//#endif
}


void FSout::close()
{
	fclose(out);
}

void FSout::printString(char *str)
{
     fprintf(out,str);
}
  
void FSout::printTime(char *str,double time)
{
	fprintf(out,str);
	fprintf(out,": %f",time);
}

void FSout::printDigit(int dig)
{
	fprintf(out, "%d", dig);
}

void FSout::printTid(int *tidSet, int tidLength)
{	
	if(tidSet==NULL)
	{
		fprintf(out, "\n");
		return;
	}

	for(int i=0; i<tidLength; i++)
	{
		if(tidSet[i]>=0)
			fprintf(out, "%d ", tidSet[i]);
	}

	fprintf(out, "\n");

}

void FSout::printOrderSet(int length, int *iset, int support)
{ 
  for(int i=0; i<length; i++) 
  {
	fprintf(out, "%d ", iset[i]);
  }
  if(support>0)
	fprintf(out, "(%d)", support);
}

void FSout::printOrderItem()
{
	for(int i=0; i<ITEM_NO; i++)
	{
		fprintf(out, "%d ", order_item[i]);
	}
	fprintf(out, "\n");
}

void FSout::printItem(int item)
{
	fprintf(out, "%d ", item);
}