// hash_table.h: interface for the hash_table class.
//
//////////////////////////////////////////////////////////////////////

#ifndef HASH_TABLE_H 
#define HASH_TABLE_H

//#if _MSC_VER > 1000
//#pragma once
//#endif // _MSC_VER > 1000
#include <vector>
#include "fsout.h"
//#include "tree.h"

class K_tree;
class Tnode;
class T_tree;
class FK_tree;

//using namespace std;
struct KeyHashNode
{
  int  *iset;
  int  length;
  int  support;
};


struct CloseHashNode
{
  int  *iset;
  int  length;
  int  support;
  int  posCount;
  //struct KeySetNode *head;
  K_tree* keys;
  //int *TidSet;
  //int TidLength;
  //int tidPointer;
  Tnode* tids;
};

typedef KeyHashNode *LPKeyHashNode;
typedef CloseHashNode *LPCloseHashNode;
typedef void * HashNode;

#define LOADFACTOR 0.9

#define OFFSET  (-1)

//#define INITSIZE 10
#define INITSIZE 16000057
//#define INITSIZE 32000011

#define MAXPOWER  32


class hash_table 
{
private:
	LPKeyHashNode *keyTable;
	LPCloseHashNode *closeTable;
      
	int keySize;  //prime
	int currKeyNum;
	int keyThreshold;
	
	int closeSize;
	int currCloseNum;
    int closeThreshold;

	int *keyMap;
	int *closeMap;

	//int *secModMap;
	int mapSize;
     
	int  curr;
	
	//for debug
	int  numInsert;
	int  numProbe;

	 bool initKeyTable(int size);
	bool initCloseTable(int size);

	bool releaseTable();

	int  getPrime(int start);
	bool isPrime(int num);

    inline int  single_mod(int i, int prime); //2^i % prime
    inline int  set_mod(int *iset, int length, int order, int *map, int size);
    inline int  getProbe(int *iset, int length, int ipass);

    
	bool rehashKeyTable();
	bool rehashCloseTable();
    inline bool compareKey(int * iset1, int length1, int *iset2, int length2); //consider the order?

    bool initModMap(int num, int * &map, int prime);
    
	
public:
	hash_table(int freqNum, int totalNum);
	virtual ~hash_table();
 
	int   insert(int *iset, int length, int support);
	
	int   insert(int * & iCloseSet, int cLen, int support, int posCount, int *iKeySet, int iLen);
	int insertEC(int *& iCloseSet, int cLen, int support, K_tree* keys=NULL);
	int insertTidPointer(int index, Tnode* tidPt);
	int   insert(LPCloseHashNode lpCloseNode);

    int   find(int *iset, int length,int & support);
    bool  begin();
	bool  next(int * & iset, int & length, int &support);

	int mergeECs(int index1, int index2);
	bool  outputClose(FSout *fsout, double & keyNum, double & closeNum, T_tree* ttree);
	bool  outputClose1(FSout *fsout, double & keyNum, double & closeNum, T_tree* ttree=NULL);

	int getCloseSize(){return closeSize;}
	LPCloseHashNode* getCloseTable(){return closeTable;}

	void releaseKeyTable();
};

#endif 
