#ifndef COMMON_H
#define COMMON_H

#include <time.h>
#include "buffer.h"
#include "hash_table.h"

#define CLOSE

#define SUDDEN 5
#define SWITCH 15

const int power2[29] = {1, 2, 4, 8,
			16, 32, 64, 128, 256,
			512, 1024, 2048, 4096, 
			8192, 16384, 32768, 65536, 
			131072, 262144, 524288,1048576, 
			2097152, 4194304, 8388608,16777216, 
			33554432, 67108864, 134217728, 268435456};	

extern int TRANSACTION_NO;   //number of transactions
extern int POSITIVE_NO;
extern int ITEM_NO;          //maximal number of items at beginning, later on, shrink to number of frequent items.
extern int THRESHOLD;        //threshold by the parameter
extern double RATIO_THRESHOLD;  //odds ratio threshould
extern int* order_item;	     // given order i, order_item[i] gives the original itemname, corresponding to table
extern int* item_order;		 // given item i, item_order[i] gives its new order, corresponding to order 
                             //	order_item[item_order[i]]=i; item_order[order_item[i]]=i; 
extern memory* fp_buf;

extern hash_table *patternTable;

void sort(int *array, int* temp, int i, int j);


static int INTSIZE=sizeof(int);

extern inline bool testRatio(int totalSupport, int positiveSupport, int dbSize, int posSize, double threshold);
#endif