#include "maintain.h"
#include "buffer.h"
#include "hash_table.h"
#include <assert.h>
#include <memory.h>
#include <time.h>


extern int ITEM_NO;
extern int MAX_ITEM;
extern int TRANSACTION_NO;
extern int* order_item;
extern memory* fp_buf;
extern hash_table *patternTable;
extern int* fullItem;
extern int fullNum;
extern int TOTAL_UPDATE;

maintain::~maintain()
{
}

int maintain::update()
{
	if(fdat == NULL ||
		removedT == NULL)
	{
		printf("input file error or removed transaction set error!");
		scanf("exit");
		exit(1);
	}

	int i;
	Transaction *Tran = new Transaction;
	assert(Tran!=NULL);
	
	for(i=0; i<3; i++)
	{
		fdat->getNextTransaction(Tran);
		switch(i)
		{
			case 0:
			TRANSACTION_NO = Tran->t[0];
			break;
		case 1:
			ITEM_NO = Tran->t[0];
			break;
		case 2:
			order_item = (int*) fp_buf->newbuf(ITEM_NO, sizeof(int));
			memcpy(order_item, Tran->t, sizeof(int)*ITEM_NO);
			break;
		}
	}

	patternTable=new hash_table(ITEM_NO, TRANSACTION_NO);
	
	int* tidset;
	int* closeSet;
	int tidlen;
	int index;
	int support=0;

	while(Tran = fdat->getNextTransactionWTid(Tran, tidset, tidlen))
	{	
		clock_t start = clock();
		//remove transactions
		support = removeTrans(tidset, tidlen);

		if(tidset && tidlen >0)
		{
			closeSet =(int*)fp_buf->newbuf(Tran->length, sizeof(int));
			memcpy(closeSet, Tran->t, sizeof(int)*Tran->length);
			//index = patternTable->insertTid(tidset, tidlen, closeSet, Tran->length, support);
			//index = patternTable->insert(closeSet, Tran->length, tidlen, 0 , NULL, 0);
			//patternTable->insertTidSet(index, tidset, tidlen);
		}
		else
		{
			fullItem =(int*)fp_buf->newbuf(Tran->length, sizeof(int));
			fullNum = Tran->length;
			memcpy(fullItem, Tran->t, sizeof(int)*Tran->length);
		}

		TOTAL_UPDATE += clock()-start;
		
	}
	delete Tran;

	return 0;
}

/*bool maintain::isSubset(int* controlSet, int conlen, int* caseSet, int caselen)
{
	return false;
}*/
int maintain::removeTrans(int*& tset, int &tlen)
{
	if(tset==NULL || removedT == NULL)
		return 0;
	
	int i, pos=0, removed = 0;

	for(i=0;i<nofRemovedT; i++)
	{
		if(removedT[i] > tset[tlen-1])
			return 1;

		for(;pos<tlen;pos++)
		{
			if(tset[pos] == removedT[i])
			{
				//remove
				tset[pos] =-255;
				removed++;
				break;
			}
			else if(tset[pos] > removedT[i])
				break;
		}
	}

	return tlen-removed;
}