#include <stdlib.h>
//#include "node.h"
#include "tree.h"
#include "common.h"


//////////////////////////////////////////////////////////////////////
// Functions of Knode Class
//////////////////////////////////////////////////////////////////////

Knode::Knode(Knode* parent, int itemname)
{
	par = parent;
	itemName = itemname;
	leftchild = NULL;
	rightsibling =NULL;
	next = NULL;
}

void Knode::init(Knode* parent, int itemname)
{
	par = parent;
	itemName = itemname;
	leftchild = NULL;
	rightsibling =NULL;
	next = NULL;
}

Knode::~Knode()
{
	Knode* temp, *temp1;;
	if(this->leftchild!=NULL)
	{
		temp=this->leftchild;
		temp1=temp->rightsibling;
		while(temp1!=NULL)
		{
			temp=temp1->rightsibling;;
			delete temp1;
			temp1=temp;
		}
		delete this->leftchild;
	}
}

Knode* Knode::append(K_tree *ktree, Knode *sib, int itemno)
{
	Knode* child;

	child = (Knode*)fp_buf->newbuf(1, sizeof(Knode));
	child->init(this, itemno);
	
	if(this->leftchild==NULL)this->leftchild=child;
	else
		sib->rightsibling = child;
	
	return child;
}

//////////////////////////////////////////////////////////////////////
// Functions of Tnode Class
//////////////////////////////////////////////////////////////////////

Tnode::Tnode(Tnode* parent, int tidname, int index, int dep)
{
	par = parent;
	tidName = tidname;
	ECindex = index;
	depth = dep;

	leftchild = NULL;
	rightsibling =NULL;
	next = NULL;
	pre = NULL;
}

void Tnode::init(Tnode* parent, int tidname, int index, int dep)
{
	par = parent;
	tidName = tidname;
	ECindex = index;
	depth = dep;

	leftchild = NULL;
	rightsibling =NULL;
	next = NULL;
	pre = NULL;
}

Tnode::~Tnode()
{
	Tnode* temp, *temp1;;
	if(this->leftchild!=NULL)
	{
		temp=this->leftchild;
		temp1=temp->rightsibling;
		while(temp1!=NULL)
		{
			temp=temp1->rightsibling;;
			delete temp1;
			temp1=temp;
		}
		delete this->leftchild;
	}
}

Tnode* Tnode::append(T_tree* ttree, Tnode* sib, int tidname, int index)
{
	Tnode* child;

	child = (Tnode*)fp_buf->newbuf(1, sizeof(Tnode));
	child->init(this, tidname, index, this->depth+1);
	
	if(this->leftchild==NULL)this->leftchild=child;
	else
		sib->rightsibling = child;

	child->next = ttree->header[tidname];
	if(child->next)
		child->next->pre = child;
	
	ttree->header[tidname] = child;

	/*if(child->pre)
	{
		if(child->pre->next!=child)
		{
			bool debug = true;
		}
	}

	if(child->next)
	{
		if(child->next->pre!= child)
		{
			bool debug = true;
		}
	}*/

	return child;
}

Tnode* Tnode::appendPath(T_tree* ttree, Tnode* start)
{
	if(ttree == NULL || start == NULL)
		return NULL;

	//start->depth--;
	Tnode* current = this->leftchild;

	//match start with the children of this node
	for(; current!=NULL; current= current->rightsibling)
	{
		if(current->tidName == start->tidName)
			break;
	}

	/*if(this->tidName == 5 && start->tidName == 7)
	{
		bool debug = true;
	}*/

	if(current == NULL) //no match
	{
		start->par = this;
		current = this->leftchild;
		this->leftchild = start;
		start->rightsibling = current;
		
		return start;
	}
	else //match
	{
		
		if(current->depth<THRESHOLD)
		{
			//remove infrequent EC
			if(start->ECindex>=0)
				patternTable->deleteEC(start->ECindex);

			if(current->ECindex>=0)
				patternTable->deleteEC(current->ECindex);
		}
		else
		{
			//merge EC
			if(start->ECindex>=0)
			{
				if(current->ECindex>=0)
				{
					current->ECindex = patternTable->mergeECs(start->ECindex, current->ECindex);
				}
				else
				{
					current->ECindex = start->ECindex;
				}
			}
		}
		
		
		//remove start from header table
		if(start->pre)
		{
			start->pre->next = start->next;
			if(start->next)
				start->next->pre = start->pre;
		}
		else
		{
			ttree->header[start->tidName] = start->next;
			if(start->next)
				start->next->pre = NULL;
		}

		Tnode* temp = start->leftchild;
		Tnode* temp1;
		
		while(temp!=NULL)
		{
			temp1 = temp->rightsibling;
			current->appendPath(ttree, temp);
			temp = temp1;
		}

		return current;
	}
}