#include "node.h"
#include "data.h"
#include "fsout.h"

class K_tree{
public:
	Knode* Root;
	Knode* header; //header of e link list of all keys

public:
	void init();
	~K_tree();

	Knode* insertKey(int* keySet, int len); //insert key patterns into tree;
	int mergeTree(K_tree *new_tree, int maxlen);
	int outputKeys(FSout *fsout, int maxlen);
};

class T_tree{
public:
	Tnode* Root;
	Tnode** header;

protected:
	Tnode* insertTidSet(int* tidSet, int tidLen, int ECindex);
	//int mergeECs(int index1, int index2);
	int printTree(FSout *fsout, Tnode* current);
	int mergeECs(Tnode* dst, Tnode* src); //merge ECs of two nodes
	int removeNode(Tnode* current); //remove node
	int linkupNode(Tnode* dst, Tnode* src); //linkup node
	int updateDepth(Tnode* current);


public:
	void init();
	~T_tree();

	void scan_DB(Data *fdat); //read tid-tree from file
	int removeTrans(int *tidSet, int tidLen);
	int outputTidSet(int *&tidSet, Tnode* tidNode, int old_support);
	int outputTree(FSout *fsout); //output tid-tree
};